(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
	typeof define === 'function' && define.amd ? define(['exports'], factory) :
	(factory((global.ReduxAwaiter = {})));
}(this, (function (exports) { 'use strict';

var Awaiters = (function () {
    function Awaiters() {
        this.awaiters = [];
    }
    Object.defineProperty(Awaiters, "Instance", {
        get: function () {
            return this.instance;
        },
        enumerable: true,
        configurable: true
    });
    Awaiters.consumer = function (action) {
        return function (_a) {
            var pattern = _a.pattern, resolve = _a.resolve;
            var isMatch = (function (action, pattern) {
                var type = action.type;
                if (typeof pattern === 'string') {
                    return type === pattern;
                }
                if (pattern instanceof RegExp) {
                    return pattern.test(type);
                }
                if (typeof pattern === 'function') {
                    return pattern(action);
                }
                return false;
            })(action, pattern);
            isMatch && resolve(action);
            return !isMatch;
        };
    };
    Awaiters.prototype.produce = function (awaiter) {
        this.awaiters = this.awaiters.concat([awaiter]);
        return this.awaiters.length;
    };
    Awaiters.prototype.consume = function (action) {
        this.awaiters = this.awaiters.filter(Awaiters.consumer(action));
        return this.awaiters.length;
    };
    Awaiters.instance = new Awaiters();
    return Awaiters;
}());
var awaiters = Awaiters.Instance;

var createAwaiterMiddleware = function () { return function () { return function (next) { return function (action) {
    awaiters.consume(action);
    return next(action);
}; }; }; };

var take = function (pattern) {
    return new Promise(function (resolve, reject) {
        if (typeof pattern !== 'string' && !(pattern instanceof RegExp) && typeof pattern !== 'function') {
            return reject(new TypeError('take(...): Invalid pattern. Expected string, RegExp or function.'));
        }
        awaiters.produce({ pattern: pattern, resolve: resolve });
    });
};

var takeAllOf = function (patterns) {
    return Promise.all(patterns.map(take));
};

var takeOneOf = function (patterns) {
    return Promise.race(patterns.map(take));
};

exports.createAwaiterMiddleware = createAwaiterMiddleware;
exports.take = take;
exports.takeAllOf = takeAllOf;
exports.takeOneOf = takeOneOf;

Object.defineProperty(exports, '__esModule', { value: true });

})));
